accounts/urls.py
from django.urls import path
from django.contrib.auth import views as auth_views

from . import views


app_name = "accounts"
urlpatterns = [
    path('login/', auth_views.LoginView.as_view(), name="login"),

    path('register/', views.UserCreateView.as_view(), name='register'),
    # path('register/', views.register, name='register'),
    
    path('group-create/', views.GroupCreateView.as_view(), name='group_create'),
    path('users/', views.UserListView.as_view(), name='users_list'),
    path('groups/', views.GroupListView.as_view(), name='groups_list'),
]

authProj/urls.py
from django.contrib import admin
from django.urls import path,include
from django.conf import settings
from django.conf.urls.static import static
from django.views.generic import TemplateView

urlpatterns = [
    path('admin/', admin.site.urls, name="admin_url"),
    path('', TemplateView.as_view(template_name="index.html")),
    path('', include("accounts.urls", namespace="accounts"))
]
if settings.DEBUG: 
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

accounts/models.py
from django.db import models
from django.contrib.auth.models import AbstractUser 



## Defining models 

class User(AbstractUser):
    email       = models.EmailField(unique=True)
    nickname    = models.CharField(max_length=50, null=True, blank=True)

    class Meta:
        permissions = (
            ("can_delete_other_users","Can delete other users"),
            ("can_rear_pokemon","Able to rear pokemon"),
        )

class Profile(models.Model):
    user        = models.OneToOneField(User, on_delete=models.CASCADE)
    bio         = models.TextField(max_length=500, blank=True)
    address     = models.CharField("Permanent Address", max_length=100)
    birth_date  = models.DateField(auto_now=False, auto_now_add=False, null=True, blank=True)
    company     = models.CharField(max_length=100, blank=True, null=True)

mainApp/models.py
from django.db import models

# Create your models here.

accounts/forms.py
from django.contrib.auth import get_user_model
from django.contrib.auth.forms import UserCreationForm

User = get_user_model()

class CustomUserCreationForm(UserCreationForm):
    class Meta:
        model = User
        fields = ['username','password1','password2','email','groups','user_permissions']

accounts/views.py
from django.views import View 
from django.urls import reverse_lazy
from django.shortcuts import render,redirect
from django.contrib.auth import authenticate , get_user_model , views as auth_views
from django.contrib.auth.models import Group
from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.db import transaction
from django.views.generic.edit import CreateView
from django.views.generic import ListView, DetailView

from .forms import CustomUserCreationForm

User = get_user_model()

def login(request, **kwargs):
    pass
  
# Registering user with function based views.
def register(request):
    if request.method == 'POST':
        form = CustomUserCreationForm(request.POST)
        if form.is_valid():
            form.save()
            messages.success(request, 'Account created successfully')
            return redirect('accounts:register')
    else:
        form = CustomUserCreationForm()
    return render(request, 'accounts/register.html', {'form': form})
    
# Registering user with class based views. 
class UserCreateView(CreateView):
    template_name = "accounts/register.html"
    model = User
    fields = ['username','email','groups','user_permissions']
    success_url = reverse_lazy("accounts:users_list")

class GroupCreateView(CreateView):
    template_name = "accounts/group_create.html"
    model = Group
    fields = "__all__"
    success_url = reverse_lazy("accounts:groups_list")
    
class GroupListView(ListView):
    template_name = "accounts/groups_list.html"
    model = Group
    context_object_name = "Groups"

class UserListView(ListView):
    model = User
    template_name = 'accounts/users_list.html'
    context_object_name = 'Users'

mainApp/views.py
from django.shortcuts import render

# Create your views here.

mainApp/templates/accounts/group_create.html
{% extends 'base/base.html' %}

{% block content %}

<form method="post">{% csrf_token %}
<table class="table">
    {{ form.as_table }}
</table>
    <input type="submit" value="Save" class="btn btn-primary">
</form>

{% endblock content %}

mainApp/templates/accounts/groups_list.html
{% extends 'base/base.html' %}

{% block content %}

<h1>Group List</h1>


<table class="table table-hover">
  <thead class="thead-dark">
    <tr>
      <th scope="col">Group ID</th>
      <th>Group Name</th>
      <th>Group Permissions</th>
    </tr>
  </thead>
  <tbody>
    {% for group in Groups %}
            <tr>
                <th scope="row">{{group.pk}}</th>
                <td>{{group.name}}</td>
                <td>
                    {% for permission in group.permissions.all %}
                        {{permission.name}} <br>
                    {% empty %}
                        --
                    {% endfor %}
                </td>
            </tr>
        {% empty %}
            <td colspan="2"> No Groups in the system !!</td>
    {% endfor %}
  </tbody>
</table>


{% endblock content %}

mainApp/templates/accounts/login.html
{% extends 'base/base.html' %}
{% block content %}

{% endblock content %}

mainApp/templates/accounts/register.html
{% extends 'base/base.html' %}

{% block content %}

<form method="post">
{% csrf_token %}
<table class="table">
    {{form.as_table}}
</table>
<input type="submit" value="Create User" class="btn btn-primary">
</form>

{% endblock content %}

mainApp/templates/accounts/users_list.html
{% extends 'base/base.html' %}

{% block content %}

<h1>User List</h1>
    <table>
        <tr>
            
        </tr>
        
    </table>
<table class="table table-hover">
  <thead class="thead-dark">
    <tr>
      <th scope="col">User ID</th>
      <th>User Name</th>
      <th>Assigned groups</th>  
      <th>Permissions</th>
      <th>Actions</th>

    </tr>
  </thead>
  <tbody>
    {% for user in Users %}
            <tr>
                <td>{{user.pk}}</td>
                <td>{{user.username}}</td>
                <td>
                    {% for group in user.groups.all %}
                        {{group.name|title}} ,
                    {% empty %}
                        --
                    {% endfor %}
                </td>
                <td>
                    {% for permission in user.get_all_permissions %}
                        {{ permission }} <br>
                    {% empty %}
                        No permissions yet
                    {% endfor %}
                </td>
                <td>
                <a class="edit" title="Edit" data-toggle="tooltip"><i class="material-icons">&#xE254;</i></a>
                <a class="delete" title="Delete" data-toggle="tooltip"><i class="material-icons">&#xE872;</i></a>
                </td>
            </tr>
        {% empty %}
            <td colspan="2"> No users in the system !!</td>
        {% endfor %}
  </tbody>
</table>
    
{% endblock content %}

mainApp/templates/base/base.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">

    {% block header %}
    {% endblock header %}
  </head>
  <body>
    {% include 'base/navbar.html' %}
    {% block content %}
    {% endblock content %}

    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
    {% block script %}
    {% endblock script %}
  </body>
</html>

mainApp/templates/base/navbar.html
<nav class="navbar navbar-expand-lg navbar-light bg-light">
  <a class="navbar-brand" href="/">DjangoAuthApp</a>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>
  <div class="collapse navbar-collapse" id="navbarNav">
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" href="{% url "accounts:users_list" %}">Users</a>
      </li>
      <li class="nav-item">
        <a class="nav-link" href="{% url "accounts:groups_list" %}">Groups</a>
      </li>
      <li class="nav-item">
        <a class="nav-link" href="{% url "accounts:register" %}">Create User</a>
      </li>
      <li class="nav-item float-md-right">
        <a class="nav-link" href="{% url "accounts:group_create" %}">Create Group</a>
      </li>
        <li class="nav-item" style="position:absolute;right:20px;">
          <a class="nav-link" href="/admin">Admin Panel</a>
        </li>
    </ul>
  </div>
</nav>

mainApp/templates/index.html
{% extends 'base/base.html' %}

{% block content %}
<h6> Welcome to Landing Page </h6>
{% endblock content %}